# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc获取收货地址列表_代客下单,2295,2295-37,sit,bs
主数据平台:后台运营系统获取收货地址列表接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import json

module = "cmdc_order_list"

# 第一步登录后台运营系统获取token
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取客户信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url33")
request_body = commonFuc().get_business_data(module, "payload33")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成随机数
customer_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取客户信息
user_id = result["data"]["list"][customer_random]["userId"]
company_id = "7"

# 第三步获取收货地址列表
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url37")
request_body = commonFuc().get_business_data(module, "payload37", company_id, user_id)
# print(request_body)
"""
 场景: 获取收货地址列表_代客下单
 用例名称：获取收货地址列表_代客下单
 输出：{"total":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())

# 获取用户默认地址信息
result = json.loads(result.content)
print(result)
# 判断有些用户没有地址
if result["data"]:
    result = {"total": result["data"]["addresses"]["total"]}
    # 将接口响应时间添加至结果中
    result["api_time"] = api_time

    # 数据库操作
    mysql_handle = mySql()
    # 获取conf.ini文件中配置的数据库信息
    host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

    # 查询数据库中对应的用户的默认地址
    sql = "SELECT count(t.addressId) FROM `cmdc-user`.cmdc_user_address t " \
          "WHERE userId = {} and companyId = {} and deleteSign = 0".format(user_id, company_id)
    print(sql)
    total = mysql_handle.selectSql(host, port, user, pwd, "cmdc-user", sql)[0][0]

    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict37", total)
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
else:
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict35_1")
    # print(check_dict)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)

