# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc可使用商品返利清单获取验证,2271,2271-44,sit,bs
主数据平台:后台运营系统可使用商品返利清单查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利发放明细
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url33")
request_body = commonFuc().get_business_data(module, "payload33")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)

# 获取返利规则信息
rebate_trip_td = result["data"]["list"][rebate_random]["rebateTripId"]

# 第三步获取可使用商品返利清单
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url35")
request_body = commonFuc().get_business_data(module, "payload35", rebate_trip_td)
"""
 场景: 验证可使用商品返利清单查询接口是否可正常使用
 用例名称：可使用商品返利清单获取验证
 输出：{"success":true,"code":"200","message":"OK"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)
result["api_time"] = api_time
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict35")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)

# 获取可使用商品数量
total = result["data"]["total"]
# print(total)
# 数据库操作
mysql_handle = mySql()
# 获取conf.ini文件中配置的数据库信息
host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

# 数据库查询返利规则1包含的可使用商品数量
sql = "SELECT t.rebatetripProductId FROM `cmdc-order`.tc_rebatetrip_pro t WHERE rebateTripId = {}".format(rebate_trip_td)
result = {"total": len(mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql))}
# print(result)
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict35_1", total)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)









