# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc商品黑名单批量导入_返利规则_商品与产品线不匹配,2271,2271-18,sit,bs
主数据平台:运营后台管理系统商品黑名单批量导入接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.handle_excel import HandleExcel
import requests
import json
import os
import random

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username2")
password = commonFuc().get_business_data(module, "password2")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers_file", cmdc_access_token)

# 获取文件
BASE_DIR = os.path.dirname(os.path.dirname(os.path.dirname(os.path.dirname(os.path.abspath(__file__)))))
file_path = BASE_DIR + "/data/cmdc_files/商品模板.xlsx"

# 第二步获取商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url_product")
request_body = commonFuc().get_business_data(module, "payload_product")
# 发送请求
result = requests.post(url, headers=headers, json=request_body)
result = json.loads(result.content)

# 生成随机数
product_random = random.randint(1, len(result["data"]["list"]) - 1)
# 获取商品code
product_code = result["data"]["list"][product_random]["relevanceCode"]

# 将商品信息写入导入模板中
excel = HandleExcel(file_path, "Sheet1")
excel.write_data(row=2, column=1, value=product_code)

# 第四步，进行文件导入操作
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url19")
request_body = commonFuc().get_business_data(module, "payload20")
# 获取文件
file = open(file_path, "rb")
files = {"file": file}

"""
场景: 验证当进行商品黑名单批量导入时，商品与产品线不匹配时，是否拦截成功
用例名称：商品黑名单批量导入_返利规则_商品与产品线不匹配
输出：{"success":false}
"""
# 发送请求
result = requests.post(url, files=files, headers=headers, data=request_body)
# 获取接口响应时间
api_time = float(result.elapsed.total_seconds())
result = json.loads(result.content)

file.close()
result = {"success": result["data"]["errMsg"]["success"]}
result["api_time"] = api_time
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict20")
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
